  <p>
    Ova minilekcija oslanja se na razumijevanje Phongovog modela osvjetljavanja. Ako se još niste
    upoznali s tim modelom, učinite to.
  </p>

  <p>
    Phongov model osvjetljavanja govori nam kako za neku zadanu točku na površini objekta izračunati
    boju odnosno intenzitet svjetlosti koji će promatrač vidjeti. Ako je oplošje tijela definirano
    kao niz poligona, postavlja se pitanje: na koji način <i>računski efikasno</i> provesti bojanje svih točaka
    poligona, a da pri tome dobijemo prihvatljivo realističnu sliku.
  </p>

  <p>
    Za razumijevanje teksta koji slijedi, prisjetite se na koji se način prikazuju tijela s
    poligonalnim opisom oplošja:
  </p>
  <ol>
    <li>provodimo uklanjanje stražnjih poligona,</li>
    <li>preostale poligone projiciramo u 2D prostor projekcije te na kraju</li>
    <li>svaki od 2D-poligona rasteriziramo postupkom skenirajuće zrake (engl. <i>scan-line algorithm</i>).</li>
  </ol>

  <p>
    Prisjetimo se postupka skenirajuće zrake. Za zadani poligon tražimo minimalnu i maksimalnu
    <i>y</i>-koordinatu među svim vrhovima. Potom bridove dijelimo na lijeve i desne. Konačno,
    u petlji prolazimo za svaki <i>y</i><sub>i</sub> od <i>y</i><sub>min</sub> do <i>y</i><sub>max</sub>
    tražimo najdesnije sjecište (označimo ga s <i>x</i><sub>L</sub>) svih lijevih bridova s pravcem (zrakom) <i>y</i>=<i>y</i><sub>i</sub>,
    te najlijevije sjecište (označimo ga s <i>x</i><sub>D</sub>) svih desnih bridova s istom zrakom.
    Jednom kad smo utvrdili <i>x</i><sub>L</sub> i <i>x</i><sub>D</sub>, crtamo vodoravni pravac
    ograničen točkama (<i>x</i><sub>L</sub>, <i>y</i><sub>i</sub>) i (<i>x</i><sub>D</sub>, <i>y</i><sub>i</sub>).
  </p>

  <p>
   Prilikom "bojanja" slikovnih elemenata između (<i>x</i><sub>L</sub>, <i>y</i><sub>i</sub>) i (<i>x</i><sub>D</sub>, <i>y</i><sub>i</sub>)
   moramo se odlučiti koju ćemo boju koristiti za svaki slikovni element, te hoćemo li, kada se pomaknemo na sljedeću skenirajuću
   zraku (na <i>y</i><sub>i</sub>+1), odluku za slikovne elemente te nove zrake nekako promijeniti.
  </p>

  <p>
    U ovoj minilekciji pojasnit ćemo tri modela sjenčanja.
  </p>
  <ol>
    <li>Konstantno sjenčanje</li>
    <li>Gouraudovo sjenčanje</li>
    <li>Phongovo sjenčanje</li>
  </ol>

